// Process.cpp
// The main computation goes here

#include <windows.h>
#include <commctrl.h>
#include "plugin.h"

// Simple random jitter, based off pseudocode from Christian Graus
// http://www.codeproject.com/cs/media/DisplacementFilters.asp

static inline void SafeGetPixel(int x, int y, MINIGRAPHIC *src,
				unsigned char *pixel)
{
  if (x<0) x = 0;
  if (y<0) y = 0;
  if (x>=(int)src->width) x = src->width-1;
  if (y>=(int)src->height) y = src->height-1;
  pixel[0] = src->bits[y*src->lineWidth+x*3+0];
  pixel[1] = src->bits[y*src->lineWidth+x*3+1];
  pixel[2] = src->bits[y*src->lineWidth+x*3+2];
}


static long rnd;
void seed(long seed) {rnd = seed;}
int rand() {return(((rnd = rnd * 214013L + 2531011L) >> 16) & 0x7fff);}

void ImageIt(int preview, int jitterx, int jittery, MINIGRAPHIC *src,
	     MINIGRAPHIC *dst)
{
  int x, y, cx, cy, sx, sy;
  unsigned char *d;

  seed(GetTickCount());
  cx = jitterx/2;
  cy = jittery/2;
  for (y=0; y<(int)src->height; y++) {
    d = dst->bits + dst->lineWidth*y;
    for (x=0; x<(int)src->width; x++) {
      if (jitterx) sx = x + (rand()%jitterx)-cx;
      else sx = x;;
      if (jittery) sy = y + (rand()%jittery)-cy;
      else sy = y;
      SafeGetPixel(sx, sy, src, d);
      d += 3;
    }
  }
}

